#ifndef _iwf_table_creation_h
#define _iwf_table_creation_h

#include "ip_secfg_IWF_VTC.h"

#define LTE_MAX_IP_SRC_IDX              4 

//#define LTE_WCDMA_CCID_MAX_VALUE        65536
//7560 corresponds to the max concurrent calls for 3 * 20MHz cells
//Requirement ID WBTS_TRS_16586
#define LTE_WCDMA_CCID_MAX_VALUE        7560
//This is the max number of peer+eNB ip's that can be configured. 
#define LTE_WCDMA_IP_MAX_LIST_VALUE    100 

#define SE_LOGFILE_BLOCK_NAMES                                   "se_logfile_block_names"
#define LTE_SYSCOM_IWF_UL_CONNECTION_DUMP_TABLE_BLOCK_NAME       "lte_syscom_iwf_ul_connection_dump_table"
#define LTE_SYSCOM_IWF_DL_CONNECTION_DUMP_TABLE_BLOCK_NAME       "lte_syscom_iwf_dl_connection_dump_table"
#define LTE_SYSCOM_IWF_IP_DUMP_TABLE_BLOCK_NAME                  "lte_syscom_iwf_ip_dump_table"
#define GTPU_MGMT_ERR_IND_TABLE_BLOCK_NAME                       "gtpu_mgmt_err_ind_table"
#define GTPU_MGMT_TRS_CONFIG_TABLE_BLOCK_NAME                    "gtpu_mgmt_trs_config_table"
#define TEID0_SICP_DATA_TABLE_BLOCK_NAME                         "teid0_srio_data_table"


#define TEID_SICP_HASH_ENTRIES_PER_BUCKET   3

#define TEID_SICP_HASH_BUCKETS          4096

#define MAX_TEID_HASH_TABLE_SIZE 28000
#define TEID_HASH_POOL      128

#define DL_GTP_MGMT_ERROR_IND_HASH_BITS                 14
#define DL_GTP_MGMT_ERROR_IND_HASH_BUCKETS              (1 << DL_GTP_MGMT_ERROR_IND_HASH_BITS)
#define DL_GTP_MGMT_ERROR_IND_HASH_MASK                 (DL_GTP_MGMT_ERROR_IND_HASH_BUCKETS - 1)
#define DL_GTP_MGMT_ERROR_IND_HASH_ENTRIES_PER_BUCKET   3 //7


#define IWF_DL_INTERNAL_HASHSIZE 4096

//TODO : abhb to check this 
#define MAX_SGW_IP_ADDRESSES                           64
#define GTPU_TRSW_FAILED                               (MAX_SGW_IP_ADDRESSES + 1)
#define GTPU_TRSW_FREE                                 0
#define GTPU_TRSW_USED                                 1

typedef enum
{
    IWF_LOG_LEVEL_NO_LOG             =  0,
    IWF_LOG_LEVEL_BASE               =  1,
    IWF_LOG_LEVEL_PKT_DUMP           = IWF_LOG_LEVEL_BASE << 0,
    IWF_LOG_LEVEL_DL_ERR_CRT_LOG     = IWF_LOG_LEVEL_BASE << 1,
    IWF_LOG_LEVEL_DL_ERR_NORMAL_LOG  = IWF_LOG_LEVEL_BASE << 2,
    IWF_LOG_LEVEL_DL_SUCC_CRT_LOG    = IWF_LOG_LEVEL_BASE << 3,
    IWF_LOG_LEVEL_DL_SUCC_NORMAL_LOG = IWF_LOG_LEVEL_BASE << 4,
    IWF_LOG_LEVEL_UL_ERR_CRT_LOG     = IWF_LOG_LEVEL_BASE << 5,
    IWF_LOG_LEVEL_UL_ERR_NORMAL_LOG  = IWF_LOG_LEVEL_BASE << 6,
    IWF_LOG_LEVEL_UL_SUCC_CRT_LOG    = IWF_LOG_LEVEL_BASE << 7,
    IWF_LOG_LEVEL_UL_SUCC_NORMAL_LOG = IWF_LOG_LEVEL_BASE << 8,
    IWF_LOG_LEVEL_TABLES_CONFIG      = IWF_LOG_LEVEL_BASE << 9,
    IWF_LOG_LEVEL_MAX                = IWF_LOG_LEVEL_BASE << 10,
    IWF_LOG_LEVEL_UL_ERR_ALL_LOG     = IWF_LOG_LEVEL_UL_ERR_CRT_LOG  | IWF_LOG_LEVEL_UL_ERR_NORMAL_LOG,
    IWF_LOG_LEVEL_UL_SUCC_ALL_LOG    = IWF_LOG_LEVEL_UL_SUCC_CRT_LOG | IWF_LOG_LEVEL_UL_SUCC_NORMAL_LOG,
    IWF_LOG_LEVEL_DL_ERR_ALL_LOG     = IWF_LOG_LEVEL_DL_ERR_CRT_LOG  | IWF_LOG_LEVEL_DL_ERR_NORMAL_LOG,
    IWF_LOG_LEVEL_DL_SUCC_ALL_LOG    = IWF_LOG_LEVEL_DL_SUCC_CRT_LOG | IWF_LOG_LEVEL_DL_SUCC_NORMAL_LOG
}IWF_LOG_LEVEL;
//unsigned int iwf_log_level           = 0;
uint32_t ipcs_lte_iwf_cleanup(void); // TODO : abhb is this function required?

uint32_t hash_table_do_hash(uint32_t key);

typedef struct
{
    uint32_t p_teid;
    teid_sicp_gtpu_mgmt_data_t sicp_gtpu_mgmt_data;
    uint16_t is_duplicate_entry :1;
    uint16_t padding            :15;
} dl_gtp_mgmt_error_ind_hash_entry_t;


typedef struct _dl_gtp_mgmt_error_ind_hash_bucket
{
    dl_gtp_mgmt_error_ind_hash_entry_t entries_gtpu_mgmt[DL_GTP_MGMT_ERROR_IND_HASH_ENTRIES_PER_BUCKET];
    struct _dl_gtp_mgmt_error_ind_hash_bucket *next;
    uint64_t entries_gtpu_mgmt_used;
} dl_gtp_mgmt_error_ind_hash_bucket_t;

typedef struct
{
    uint16_t           ccid_ul;
    uint32_t           teid;
    UIpAddress_t       uip_src;
    uint8_t            ip_ver;
    uint8_t            entry;
} ta_teid_ccid_hash_table_t;

typedef struct
{
    uint32_t    teid;
    sicp_data_t sicp_data;
    uint16_t    padding;
} teid_sicp_hash_entry_t;


typedef struct _teid_sicp_hash_bucket
{
    teid_sicp_hash_entry_t entries[TEID_SICP_HASH_ENTRIES_PER_BUCKET];
    struct _teid_sicp_hash_bucket * next;
    uint64_t entries_used;
} teid_sicp_hash_bucket_t;

typedef union
{
    teid_sicp_hash_bucket_t     teid_sicp_table;
    ta_teid_ccid_hash_table_t   ta_teid_ccid_table;
}shared_hash_table_t;


typedef struct
{// ASWINI to check this : whether it should be 32 or 64
  uint32_t lte_syscom_iwf_ul_connection_dump_table_ptr;
  uint32_t lte_syscom_iwf_dl_connection_dump_table_ptr;
  uint32_t lte_syscom_iwf_ip_dump_table_ptr;
  uint32_t gtpu_mgmt_err_ind_table_ptr;
  uint32_t gtpu_mgmt_trs_config_table_ptr;
  uint32_t ta_iwf_lookup_table_ptr;
  uint32_t ta_teid_ccid_table_entry_table_ptr;
  uint32_t ta_osaid_teid_ccid_table_ptr;
  uint32_t teid0_sicp_data_table_ptr;
} logfile_block_names_ptr_t;

typedef struct 
{ 
   uint16_t vlanId; 
   uint64_t dl_bh_total_pkt_cntr; 
   uint64_t dl_bh_total_bytes_cntr; 
   uint64_t dl_bh_total_drop_pkt_cntr; 
   uint64_t ul_bh_total_pkt_cntr; 
   uint64_t ul_bh_total_bytes_cntr;

   uint64_t dl_bh_total_pkt_cntr_ipv4; 
   uint64_t dl_bh_total_bytes_cntr_ipv4;
   uint64_t dl_bh_total_drop_pkt_cntr_ipv4;
   uint64_t ul_bh_total_pkt_cntr_ipv4; 
   uint64_t ul_bh_total_bytes_cntr_ipv4;

   uint64_t dl_bh_total_pkt_cntr_ipv6; 
   uint64_t dl_bh_total_bytes_cntr_ipv6;
   uint64_t dl_bh_total_drop_pkt_cntr_ipv6;
   uint64_t ul_bh_total_pkt_cntr_ipv6; 
   uint64_t ul_bh_total_bytes_cntr_ipv6;

   uint64_t ul_mcast_pkt_cntr_ipv6;
   uint64_t ul_mcast_bytes_cntr_ipv6;
   uint64_t dl_mcast_pkt_cntr_ipv6;
   uint64_t dl_mcast_bytes_cntr_ipv6;
   uint64_t dl_mcast_disc_pkt_cntr_ipv6;
   uint64_t dl_mcast_disc_bytes_cntr_ipv6;

   uint64_t ul_bh_mcast_total_bytes_cntr_ipv4;
   uint64_t ul_bh_mcast_total_pkt_cntr_ipv4;

   uint64_t dl_bh_mcast_total_pkt_cntr;
   uint64_t dl_bh_mcast_total_bytes_cntr;
   uint64_t dl_bh_mcast_disc_total_pkt_cntr;
   uint64_t dl_bh_mcast_disc_total_bytes_cntr;
   
   uint64_t ul_bh_mcast_total_pkt_cntr;
   uint64_t ul_bh_mcast_total_bytes_cntr;


}_ipCounters;


 int init_lte_iwf_table_dl_ul (void);

char * fzm_enet_inet_ntoa_IPv6_r (UIpv6Address_t ina, char * buf);
char * fzm_enet_inet_ntoa_r (UIpv4Address_t ina, char *buf);
uint32_t getUserPathIPIndex(iwf_ip_addr_t *trsUpIp);

//Funciton to check if IPV6 U-plane IP
bool is_ip_U_plane_ipv6(struct in6_addr *ipv6addr);

static inline bool is_ip_addr_null (iwf_ip_addr_t * ip_addr)
{
    if(ip_addr->version == IPv6)
    {
        return ((ip_addr->addr_u.ipv6Address.ipa_32[0] ||
                 ip_addr->addr_u.ipv6Address.ipa_32[1] ||
                 ip_addr->addr_u.ipv6Address.ipa_32[2] ||
                 ip_addr->addr_u.ipv6Address.ipa_32[3]) == 0 ? true : false);
    }
    else
    {
       return((ip_addr->addr_u.ipv4Address.ipa_32 )== 0 ? true : false);
    }
}


static inline bool ip_is_equal (iwf_ip_addr_t * ip_a, iwf_ip_addr_t * ip_b)
{

   if(ip_a->version == IPv6)
   {
        if ((ip_a->addr_u.ipv6Address.ipa_32[0] == ip_b->addr_u.ipv6Address.ipa_32[0]) &&
            (ip_a->addr_u.ipv6Address.ipa_32[1] == ip_b->addr_u.ipv6Address.ipa_32[1]) &&
            (ip_a->addr_u.ipv6Address.ipa_32[2] == ip_b->addr_u.ipv6Address.ipa_32[2]) &&
            (ip_a->addr_u.ipv6Address.ipa_32[3] == ip_b->addr_u.ipv6Address.ipa_32[3]) &&
            (ip_a->version == ip_b->version))
         {
                return true;
         }
         else
         {
                return false;
         }
   }
   else
   {
/*
               printk(" i am checked here\n");
                       printk("ip_a->addr_u.ipv4Address.ipa_32 %0x",ip_a->addr_u.ipv4Address.ipa_32);
                               printk("ip_b->addr_u.ipv4Address.ipa_32 %0x",ip_b->addr_u.ipv4Address.ipa_32);
                               */
        if ((ip_a->addr_u.ipv4Address.ipa_32 == ip_b->addr_u.ipv4Address.ipa_32) && ip_a->version == ip_b->version)
                return true;
        else
                return false;
   }

}
/*****************************************************************************
 * Method Name        : is_ip_addr_null_n
 *
 * Input Parameters   : iwf_ip_addr_t_n *ip_a
 * 
 * Returns            : 
 * 
 * Description        : check whether the IP is NULL or not
 *
*****************************************************************************/
static inline bool is_ip_addr_null_n (iwf_ip_addr_t_n * ip_addr)
{
    if(ip_addr->version == IPv6)
    {
        return ((ip_addr->addr_u.ipv6Address.ipa_32[0] ||
                 ip_addr->addr_u.ipv6Address.ipa_32[1] ||
                 ip_addr->addr_u.ipv6Address.ipa_32[2] ||
                 ip_addr->addr_u.ipv6Address.ipa_32[3]) == 0 ? true : false);
    }
    else
    {
       return((ip_addr->addr_u.ipv4Address.ipa_32 )== 0 ? true : false);
    }
}


/*****************************************************************************
 * Method Name        : ip_is_equal_n
 *
 * Input Parameters   : iwf_ip_addr_t_n *ip_a & iwf_ip_addr_t * ip_b
 * 
 * Returns            : 
 * 
 * Description        : compare two IPs
 *
*****************************************************************************/
static inline bool ip_is_equal_n (iwf_ip_addr_t_n * ip_a, iwf_ip_addr_t * ip_b)
{

   if(ip_a->version == IPv6)
   {
        if ((ip_a->addr_u.ipv6Address.ipa_32[0] == ip_b->addr_u.ipv6Address.ipa_32[0]) &&
            (ip_a->addr_u.ipv6Address.ipa_32[1] == ip_b->addr_u.ipv6Address.ipa_32[1]) &&
            (ip_a->addr_u.ipv6Address.ipa_32[2] == ip_b->addr_u.ipv6Address.ipa_32[2]) &&
            (ip_a->addr_u.ipv6Address.ipa_32[3] == ip_b->addr_u.ipv6Address.ipa_32[3]) &&
            (ip_a->version == ip_b->version))
         {
                return true;
         }
         else
         {
                return false;
         }
   }
   else
   {
        if ((ip_a->addr_u.ipv4Address.ipa_32 == ip_b->addr_u.ipv4Address.ipa_32) && ip_a->version == ip_b->version)
                return true;
        else
                return false;
   }
}

uint8_t insert_ip(iwf_ip_addr_t ip);
void delete_ip(uint8_t index);

#endif
