// *****************************************************************************
// PROJECT NAME     :   FZM
// Component name   :   l2switch_cfg.h
// Filename         :   
// Author           :   Soja Sasi
// Date created     :   30.10.2015
// Date changed     :   -
// -----------------------------------------------------------------------------
// Description      :   
//
// -----------------------------------------------------------------------------
// Revision history :
// date       | author         | comments
// ---------- + -------------- +----------------------------------------------------
// 30.10.2015 | Soja Sasi     | Initial version
// 30.10.2015 | Manish Katti| Added extension header part
//            |                |
// *****************************************************************************
// Copyright (c) Nokia 2015
// All rights reserved.
// Licensed material - property of Nokia
// *****************************************************************************

#ifndef __SWITCH_VLAN_FZM_H__
#define __SWITCH_VLAN_FZM_H__


#include "ip_secfg_IWF_VTC.h"

#define MAX_NUM_LOGICAL_INTF 3
#define ETH_VLAN_TYPE 33024
#define INVALID_VLAN_ID 5000

enum
{
	DISABLE,
	ENABLE
};

typedef enum _acceptframetype_t
{
   ADMIT_TAGGED = 0,
   ADMIT_ALL = 2
}acceptframetype_t;

typedef enum _logicalIntfType
{
   INTF_ETH0,
   INTF_ETH1,
   INTF_ETH3,
   INTF_INVALID
}logicalIntfType;

typedef struct _svfCfgInfo
{
    acceptframetype_t AcceptFrameType;  
    vlan_filter vidfilter[MAX_VLAN_FILTERS];
}svfCfgInfo;

uint8_t getPortNumPerInterface(const char* logicalIntfName);
uint16_t applyVlanFilter(uint16_t vlan_id, uint16_t in_port);
void initVlanConfig(void);
#endif

